// satDlg.cpp : implementation file
//

#include "stdafx.h"
#include "sat.h"
#include "Projectile.h"
#include "satDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CSatDlg dialog

CSatDlg::CSatDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CSatDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CSatDlg)
		// NOTE: the ClassWizard will add member initialization here
	m_fRadEarth = 150;
	m_bSettingVelocity = FALSE;
	m_nTrajIdx = 0;
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CSatDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CSatDlg)
		// NOTE: the ClassWizard will add DDX and DDV calls here
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CSatDlg, CDialog)
	//{{AFX_MSG_MAP(CSatDlg)
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_WM_LBUTTONDOWN()
	ON_WM_LBUTTONUP()
	ON_WM_MOUSEMOVE()
	ON_WM_TIMER()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CSatDlg message handlers

BOOL CSatDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// TODO: Add extra initialization here
	
	return TRUE;  // return TRUE  unless you set the focus to a control
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CSatDlg::OnPaint() 
{
	CPaintDC dc(this); // device context for painting
	CRect rect;
	GetClientRect(&rect);

	if (IsIconic())
	{

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		m_ptCenter.x = rect.Width()/2;
		m_ptCenter.y = rect.Height()/2;

		CRect rtCircle(CPoint(m_ptCenter.x - m_fRadEarth, m_ptCenter.y - m_fRadEarth), 
			CPoint(m_ptCenter.x + m_fRadEarth, m_ptCenter.y + m_fRadEarth));

		dc.Ellipse(rtCircle);

		if(m_bSettingVelocity)
		{
			dc.MoveTo(m_ptStartPos + m_ptCenter);
			dc.LineTo(m_ptStartPos + m_ptCenter + m_ptStartVel);
		}

		dc.MoveTo(m_ptTrajectory[0]);
		for(int i = 0; i< m_nTrajIdx; i++)
		{
			dc.LineTo(m_ptTrajectory[i]);
		}

		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CSatDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CSatDlg::OnLButtonDown(UINT nFlags, CPoint point) 
{
	// TODO: Add your message handler code here and/or call default
	CPoint pt;
	pt = m_ptCenter - point;
	if(fabs(hypot(pt.x, pt.y)-m_fRadEarth) < 5)
	{
		m_bSettingVelocity = TRUE;
		m_ptStartPos = point - m_ptCenter;

	}
	
	CDialog::OnLButtonDown(nFlags, point);
}

void CSatDlg::OnLButtonUp(UINT nFlags, CPoint point) 
{
	// TODO: Add your message handler code here and/or call default
	if(m_bSettingVelocity)
	{
		m_bSettingVelocity = FALSE;
	//	MessageBox("ccc");
		LaunchProj();
	}
	CDialog::OnLButtonUp(nFlags, point);
}

void CSatDlg::OnMouseMove(UINT nFlags, CPoint point) 
{
	// TODO: Add your message handler code here and/or call default
	if(m_bSettingVelocity)
	{
		m_ptStartVel = point - m_ptCenter - m_ptStartPos;
		Invalidate();
	}



	CDialog::OnMouseMove(nFlags, point);
}

void CSatDlg::OnTimer(UINT nIDEvent) 
{
	// TODO: Add your message handler code here and/or call default
	switch(nIDEvent)
	{
	case 1:
	//	CPoint pt;
		m_proj.Develop();
		m_ptTrajectory[m_nTrajIdx++] = m_ptCenter + m_proj.m_ptCurPos.ConvertToCPoint();
		Invalidate(FALSE);
		if(m_nTrajIdx == 3000)
			KillTimer(1);
		break;
	}
	CDialog::OnTimer(nIDEvent);
}

void CSatDlg::LaunchProj()
{

	m_proj.m_ptStartPos = m_ptStartPos;
	m_proj.m_ptStartVel = m_ptStartVel;
	m_proj.m_ptCurPos = CFPoint(m_ptStartPos);
	m_proj.m_ptCurVel = CFPoint(m_ptStartVel);
	
	m_nTrajIdx = 0;
	m_ptTrajectory[m_nTrajIdx++] = m_ptCenter + m_proj.m_ptCurPos.ConvertToCPoint();
	SetTimer(1, 10, NULL);

}
